function [bhat Hx Fx Sx KMdist bknots]=HCNSsupd(x, status,kgon)
%Interior function for the HCNS routine.
%Not of primary interest for the user.
xcc=x(status==0);

loc=9;
[knotone]=firstknot(x,status,0.001);
%[knottwo]=firstknot(x,status,0.10);
%[knotthree]=firstknot(x,status,0.20);
%[knotfour]=firstknot(x,status,0.30);

knotone
%knottwo
%knotthree
%knotfour

poss=prctile(xcc,[0 2.5 5 10 20 40 50 60 80 100]);
%poss=[knotone linspace(min(xcc),max(xcc),loc)];

poss=sort(poss)
knloc = combnk(1:loc,6);sizekn=size(knloc);sizr=sizekn(1);

AA=zeros(sizekn);
KMd=ones(sizekn(1),1);
%till=sizr;
for i=1:sizr; 
   % if i==round(0.50*till);disp('25 percent of calculations are done...');end
   % if i==till;disp('50 percent of calculations are done... ');end
    AA(i,:)=poss(knloc(i,:));
    tryknots=AA(i,:);
    [~, ~, ~, ~, KMds]=Hnschoose(x,status,tryknots,kgon);
    KMd(i)=KMds;
end;

best=find(KMd==min(KMd), 1 );
bestknots=AA(best,:);
[~ , ~ , ~, ~, KMdists]=Hnschoose(x,status,bestknots,kgon);



%-----Now the same with the percentiles:
% poss=prctile(xcc,[0 2.5 5 10 20 40 50 60 80 100]);
% KMp=zeros(1,sizr);
% for i=1:sizr; 
%     %if i==round(0.50*till);disp('75 percent of calculations are done...');end
%     %if i==till;disp('100 percent of calculations are done. ');end
%     AA(i,:)=poss(knloc(i,:));
%     tryknots=AA(i,:);
%     [~ , ~ , ~, ~, KMprc]=Hnschoose(x,status,tryknots,kgon);
%     KMp(i)=KMprc;
% end;
% 
% bestprc=find(KMp==min(KMp), 1 );
% bestknotsprc=AA(bestprc,:);
% [~ , ~ , ~, ~, KMdistp]=Hnschoose(x,status,bestknotsprc,kgon);
% 
% % Choose between the 210 linspaced and 210 prc's:
% if KMdists<KMdistp
%     [bhat Hx Fx Sx KMdist bknots]=Hnschoose(x,status,bestknots,kgon);
% else
%     [bhat Hx Fx Sx KMdist bknots]=Hnschoose(x,status,bestknotsprc,kgon);
% end


[bhat Hx Fx Sx KMdist bknots]=Hnschoose(x,status,bestknots,kgon);

end



function [bs Hs Fs Ss KMds ks]=Hnschoose(x,status,knots,kgon)
            if length(unique(knots))~=6;bs=NaN; Hs=NaN; Fs=NaN; Ss=NaN; KMds=Inf; ks=NaN;
            else
            %[y x]=ecdf(x,'censoring',status,'function','cumulative hazard');
            [y, x]=ecdfdoubly(x,status);y=1-y;y=-log(y); %S=exp(-H) %log(S)=-H
            y(end)=y(end-1);
            x1=x;y1=y;t=knots;
            
            X=[(x-t(1)).^3.*(x>t(1))  (x-t(2)).^3.*(x>t(2))  (x-t(3)).^3.*(x>t(3)) (x-t(4)).^3.*(x>t(4)) (x-t(5)).^3.*(x>t(5))  ];

            options = optimset('LargeScale', 'off','Display', 'off','MaxFunEvals',18000,'MaxIter',18000);
            [A,k,Aeq]=conlsqlin(t,kgon); %find the required constraints using the knots "t".
            [bhat] = lsqlin(X,y,A,(k),Aeq,0,[],[],[],options);

            g=bhat;
            % The last parameter can be explicitly calculated by:
            g(6)=(g(1).*(t(1)-t(5))+g(2).*(t(2)-t(5))+g(3).*(t(3)-t(5))+g(4).*(t(4)-t(5)))./(t(5)-t(6));

            %--------------------------------------------
            %DONE WITH ESTIMATING THE SPLINE COEFFICIENTS
            %--------------------------------------------

            Hs=@(x) g(1).*(x-t(1)).^3.*(x>t(1))+ g(2).*(x-t(2)).^3.*(x>t(2))+ g(3).*(x-t(3)).^3.*(x>t(3))+ g(4).*(x-t(4)).^3.*(x>t(4))+ g(5).*(x-t(5)).^3.*(x>t(5))+ g(6).*(x-t(6)).^3.*(x>t(6)) ;
            Fs=@(x)  1-exp(-(g(1).*(x-t(1)).^3.*(x>t(1))+ g(2).*(x-t(2)).^3.*(x>t(2))+ g(3).*(x-t(3)).^3.*(x>t(3))+ g(4).*(x-t(4)).^3.*(x>t(4))+ g(5).*(x-t(5)).^3.*(x>t(5))+ g(6).*(x-t(6)).^3.*(x>t(6))));
            Ss=@(x)    exp(-(g(1).*(x-t(1)).^3.*(x>t(1))+ g(2).*(x-t(2)).^3.*(x>t(2))+ g(3).*(x-t(3)).^3.*(x>t(3))+ g(4).*(x-t(4)).^3.*(x>t(4))+ g(5).*(x-t(5)).^3.*(x>t(5))+ g(6).*(x-t(6)).^3.*(x>t(6))));


            KMds=sum((Hs(x1)-y1).^2);
            ks=knots;bs=g;
            end


 
end