function [inter slo]=approxM(k)
%Interior function for the HCNS routine.
%Derive the segments 
%of the approximation of A of M.

xc=2;yc=2; %center of the ellipse
theta=-pi/4; %tilt of the major axis

a=2.4494897462427740464363523642533;% major semi axis
b=sqrt(2);  % minor semi axis

N=12*k; %Chose how many points you want
N=N+1;
%----Now I have everything I need so I apply the code:


df=2*pi/(N-1);CT=cos(theta);ST=sin(theta);
CDP=cos(df);SDP=sin(df);CNDP=1;SNDP=0;

x=zeros(1,N);y=x;
for n=1:N
    xp=a*CNDP;yp=b*SNDP;
    x(n)=xc+xp*CT-yp*ST;
    y(n)=yc+xp*ST+yp*CT;
    
    TEMP=CNDP*CDP-SNDP*SDP;
    SNDP=SNDP*CDP+CNDP*SDP;
    CNDP=TEMP;
end



 M1=[x' y'];M1(max(size(M1)),:)=[];
 M=circshift(M1,k);
 x=M(:,1);y=M(:,2);
 inter=zeros(1,8*k);slo=inter;
 for i=1:(8*k)
     X=[1 x(i);1 x(i+1)];
     yy=[y(i);y(i+1)];
     bs=X\yy;
     inter(i)=bs(1);
     slo(i)=bs(2);
 end
 %Change the signs due to the way I
 % define the line y-g0-g1*x=0.
 % Check the notebook:
 inter=-inter';
 slo=-slo';
 