function [F, S, H, h, f, bhat, knots, exitflag]=rcshr(t,status,z,atz,plotss)

if size(t,2)~=1;t=t';end
if size(status,2)~=1;status=status';end

if size(t,2)~=1;error('time data must be a signl3 column');end
if size(status,2)~=1;error('status must be a signle column');end


if nargin<3;z=0;atz=0;end %no covariates case (otherwise a single covariate z is considered)
if nargin<4;plotss=0;end
%if size(z,2)~=1;z=z';error('z must be a signle column');end
if nargin>2;if size(z,2)~=1;z=z';end;if isempty(z)==1;z=0;atz=0;end;end
if nargin>=4 && isempty(atz)==1;atz=0;end

%-----begin Harrell-------------------
%k=linspace(min(t), max(t), 4);knots=k;
%k=[min(t) prctile(t(status==0),[25 75 95])];knots=k;
%k=prctile(t(status==0),[5 25 75 95]);knots=k;
k=linspace(min(t(status==0)), max(t(status==0)), 4);knots=k;


X2=@(x) (x-k(1)).^3.*(x>k(1))-(x-k(3)).^3.*(x>k(3)).*(k(4)-k(1))./(k(4)-k(3))+(x-k(4)).^3.*(x>k(4)).*(k(3)-k(1))./(k(4)-k(3));
X3=@(x) (x-k(2)).^3.*(x>k(2))-(x-k(3)).^3.*(x>k(3)).*(k(4)-k(2))./(k(4)-k(3))++(x-k(4)).^3.*(x>k(4)).*(k(3)-k(2))./(k(4)-k(3));

int1=  1/4*(t-k(1)).^4.*(t>k(1));
int2=  1/4*(t-k(2)).^4.*(t>k(2));
int3=  1/4*(t-k(3)).^4.*(t>k(3));
int4=  1/4*(t-k(4)).^4.*(t>k(4));

AA=int1-(k(4)-k(1))./(k(4)-k(3)).*int3+(k(3)-k(1))./(k(4)-k(3)).*int4;
BB=int2-(k(4)-k(2))./(k(4)-k(3)).*int3+(k(3)-k(2))./(k(4)-k(3)).*int4;

%With intercept:
%disp('With Intercept')
options=optimset('MaxFunEvals',100000,'MaxIter',100000);
%logL=@(b) ((-(sum( (1-status).*(log(b(2)+b(3).*t+b(4).*X2(t)+b(5).*X3(t))+z.*b(1)) - ( (b(2).*t+b(3).*t.^2./2+b(4).*AA+b(5).*BB).*exp(b(1).*z)) ))));
%all kinds of censoring:
%init=[2.0000    0.1    0.1349    0.1955   -0.5658]
init=[0.1 0.1 0.1 0.1 0.1 ];

% if nargin>=3 && z~=0%that is if there is a covariate
%periorismos gia thetiko hazard rate: A*pars>0 opou A: [   0     1    1   (t-k(1)).^3.*(t>k(1))+((k(1)-k(4))./(k(4)-k(3))).*(t-k(3)).^3.*(t>k(3))+ ((k(1)-k(3))./(k(3)-k(4))).*(t-k(4)).^3.*(t>k(4))  (t-k(2)).^3.*(t>k(2))+((k(2)-k(4))./(k(4)-k(3))).*(t-k(3)).^3.*(t>k(3))+ ((k(2)-k(3))./(k(3)-k(4))).*(t-k(4)).^3.*(t>k(4)) ]
    logL=@(b) ((-(sum( (status==0).*((log(b(2)+b(3).*t+b(4).*X2(t)+b(5).*X3(t))+z.*b(1)) - ( (b(2).*t+b(3).*t.^2./2+b(4).*AA+b(5).*BB).*exp(b(1).*z)))+(status==1).*(-(( (b(2).*t+b(3).*t.^2./2+b(4).*AA+b(5).*BB).*exp(b(1).*z))))+(status==-1).*log(1-exp(-(( (b(2).*t+b(3).*t.^2./2+b(4).*AA+b(5).*BB).*exp(b(1).*z)))))))));
    if z~=0
        [blik , ~, exitflag]=fminsearchbnd(logL,[init],  [-Inf 0 0 -Inf -Inf], [Inf Inf Inf Inf Inf],options);
        %[blik , ~, exitflag]=fmincon(logL,init,  [-Inf 0 0 -Inf -Inf], [Inf Inf Inf Inf Inf],-[   0     1    1   (median(t)-k(1)).^3.*(median(t)>k(1))+((k(1)-k(4))./(k(4)-k(3))).*(median(t)-k(3)).^3.*(median(t)>k(3))+ ((k(1)-k(3))./(k(3)-k(4))).*(median(t)-k(4)).^3.*(median(t)>k(4))  (median(t)-k(2)).^3.*(median(t)>k(2))+((k(2)-k(4))./(k(4)-k(3))).*(median(t)-k(3)).^3.*(median(t)>k(3))+ ((k(2)-k(3))./(k(3)-k(4))).*(median(t)-k(4)).^3.*(median(t)>k(4))],0,options);
    else
        %[blik , ~, exitflag]=fminsearchbnd(logL,[init],   [10^(-4) 10^(-4) 10^(-4) 10^(-4) 10^(-4)],    [0   Inf Inf Inf Inf],options);
        [blik , ~, exitflag]=fminsearchbnd(logL,[init],   [0 0 0 0 0],    [Inf   Inf Inf Inf Inf],options);
    end
        
    hghat=blik(1);
    b0=blik(2);b1=blik(3);b2=blik(4);b3=blik(5);
    b4=b2.*(k(1)-k(4))+b3.*(k(2)-k(4));
    b4=b4./(k(4)-k(3));
    b5=b2.*(k(1)-k(3))+b3.*(k(2)-k(3));
    b5=b5/(k(3)-k(4));

    
    bhat=[b0 b1 b2 b3 b4 b5]';



h=@(x) b0+b1.*x+b2.*(x-k(1)).^3.*(x>k(1))+b3.*(x-k(2)).^3.*(x>k(2))+b4.*(x-k(3)).^3.*(x>k(3))+b5.*(x-k(4)).^3.*(x>k(4));
gr=min(t):0.01:max(t);
gr2=gr;
%gr2=(min(t)-prctile(t,30)):0.01:(max(t)-prctile(t,30));


H0rcs= @(x) b0*x+b1.*x.^2./2+b2.*(1/4*(x-k(1)).^4.*(x>k(1)))+b3.*(1/4*(x-k(2)).^4.*(x>k(2)))+b4.*(1/4*(x-k(3)).^4.*(x>k(3)))+b5.*(1/4*(x-k(4)).^4.*(x>k(4)));
%S0rcs=@(x) exp(-(b0*x+b1.*x.^2./2+b2.*(1/4*(x-k(1)).^4.*(x>k(1)))+b3.*(1/4*(x-k(2)).^4.*(x>k(2)))+b4.*(1/4*(x-k(3)).^4.*(x>k(3)))+b5.*(1/4*(x-k(4)).^4.*(x>k(4)))));

HZrcs=@(x) H0rcs(x).*exp(hghat.*atz); 
SZrcs=@(x) exp(-HZrcs(x));

%F S H h f 
if plotss==0
    kjh=1;%disp('no plots asked')
elseif plotss==1
    plot(gr,1-SZrcs(gr));title('cumulative distribution');
elseif plotss==2
    plot(gr,SZrcs(gr));title('survival');
elseif plotss==3
    plot(gr,HZrcs(gr));title('cumulative hazard');
elseif plotss==4
    plot(gr,h(gr).*exp(hghat.*atz));title('hazard rate');
elseif plotss==5
    plot(gr,(h(gr).*exp(hghat.*atz)).*SZrcs(gr));title('density');
else error('invalid input argument for plotss');
end
% ISE90(epan)= quadgk(@(x) (SZreal(x)-SZrcs(x)).^2,0.7733,2.1612);
% ISE80(epan)= quadgk(@(x) (SZreal(x)-SZrcs(x)).^2,0.9931,1.9190);
% ISE70(epan)= quadgk(@(x) (SZreal(x)-SZrcs(x)).^2,1.1612,1.7420);

%====outputs

F=@(x) 1-SZrcs(x);
S=@(x) SZrcs(x);
H=@(x) HZrcs(x);
h=@(x) h(x).*exp(hghat.*atz);
f=@(x) h(x).*S(x);

fx=f(gr2);hx=h(gr2);Fx=F(gr2);Sx=S(gr2);
%if min(fx)<0;warning('Negative values of density');end
if min(Fx)<0 || max(Fx)>1;warning('Fx not in [0,1]');end
if min(Fx)<0 || max(Fx)>1;exitflag=100;end
if issorted(Fx)~=1;warning('Fx not monotone');end
%if min(hx)<0;warning('Negative values of hazard rate');end
% issortedddd=issorted(Fx)
% Fx
end