
function out=rocLODkern(xcen1,xcen2,status1, status2, cutlow, cutupp)


[a1hat, b1hat]=normfit(xcen1(status1==0));
[a2hat, b2hat]=normfit(xcen2(status2==0));
%break

xa=[xcen1 xcen1];
xa1=xa(:,1);
xa1(status1==-1)=-Inf;
xa2=xa(:,2);
xa2(status1==1)=Inf;
xa=[xa1 xa2];


xb=[xcen2 xcen2];
xb1=xb(:,1);
xb1(status2==-1)=-Inf;
xb2=xb(:,2);
xb2(status2==1)=Inf;
xb=[xb1 xb2];


[parsa, ~, ~, ~, exitflag1]=normfitc(xa,1,[a1hat b1hat],[]);
[parsb, ~, ~, ~, exitflag2]=normfitc(xb,1,[a2hat b2hat],[]);

if exitflag1~=1;warning('Fitting normal to left censored data failed for the healthy');end
if exitflag2~=1;warning('Fitting normal to left censored data failed for the diseased');end


a1hat=parsa(1);b1hat=parsa(2);
a2hat=parsb(1);b2hat=parsb(2);



%fromt=X(end-1);
scores=[xcen1;xcen2];

logos1left=length(find(status1==-1));
logos2left=length(find(status2==-1));

logos1right=length(find(status1==1));
logos2right=length(find(status2==1));

%scores=[xcen1;xcen2];
% labels=[xcen1.*0;xcen2./xcen2]
% [Xnai Ynai Tnai AUCnai]=perfcurve(labels,scores,1);
% 
% plot(Xnai, Ynai,'b')

%rocparam=@(t) 1-normcdf(norminv(a1hhat,b1hat),a2hat,b2hat)
%t=0:0.01:1;
%plot(t,rocparam(t),'c')



improct=[];
for impnum=1:30
  impnum;
  
%==================Deal with left censoring
rimp=[];kkk=0;
cut=cutlow;
for i=1:logos1left;
    while length(rimp)<logos1left;r=normrnd(a1hat,b1hat,1,1);
    if r<cut;rimp=[rimp;r];end;
    end
end
ximp1=rimp;
%disp('fine....')
rimp=[];
for i=1:logos2left;
    while length(rimp)<logos2left;r=normrnd(a2hat,b2hat,1,1);
    if r<cut;rimp=[rimp;r];end;
    end
end
ximp2=rimp;

xcen1(status1==-1)=ximp1;
xcen2(status2==-1)=ximp2;

%==========================Deal with right censoring

rimp=[];kkk=0;
cut=cutupp;
for i=1:logos1right;
    while length(rimp)<logos1right;r=normrnd(a1hat,b1hat,1,1);
    if r>cut;rimp=[rimp;r];end;
    end
end
ximp1=rimp;
%disp('fine....')
rimp=[];
for i=1:logos2right;
    while length(rimp)<logos2right;r=normrnd(a2hat,b2hat,1,1);
    if r>cut;rimp=[rimp;r];end;
    end
end
ximp2=rimp;

xcen1(status1==1)=ximp1;
xcen2(status2==1)=ximp2;





%scores=[xcen1;xcen2];
%labels=[zeros(length(xcen1),1);ones(length(xcen2),1)];
%[Ximp Yimp Timp AUCimp(impnum)]=perfcurve(labels,scores,1);
%AUCimp(impnum);
%hold on
%plot(Ximp,Yimp,'g')

%=========kernels================================================
W1a=xcen1;W1b=xcen2;
h1a=0.9*min(std(W1a),iqr(W1a)/1.34)*length(W1a)^(-0.2);
h1b=0.9*min(std(W1b),iqr(W1b)/1.34)*length(W1b)^(-0.2);

Sinv1a=@(t) ksdensity(W1a,1-t,'width',h1a,'function','icdf');
rock=@(t) 1-ksdensity(W1b,Sinv1a(t),'width',h1b,'function','cdf');
%tt=0:0.01:1;
%plot(tt,rock(t),'y')
%=========kernels================================================


if impnum==1;rock1=@(t) rock(t);end
if impnum==2;rock2=@(t) rock(t);end
if impnum==3;rock3=@(t) rock(t);end
if impnum==4;rock4=@(t) rock(t);end
if impnum==5;rock5=@(t) rock(t);end
if impnum==6;rock6=@(t) rock(t);end
if impnum==7;rock7=@(t) rock(t);end
if impnum==8;rock8=@(t) rock(t);end
if impnum==9;rock9=@(t) rock(t);end
if impnum==10;rock10=@(t) rock(t);end
if impnum==11;rock11=@(t) rock(t);end
if impnum==12;rock12=@(t) rock(t);end
if impnum==13;rock13=@(t) rock(t);end
if impnum==14;rock14=@(t) rock(t);end
if impnum==15;rock15=@(t) rock(t);end
if impnum==16;rock16=@(t) rock(t);end
if impnum==17;rock17=@(t) rock(t);end
if impnum==18;rock18=@(t) rock(t);end
if impnum==19;rock19=@(t) rock(t);end
if impnum==20;rock20=@(t) rock(t);end
if impnum==21;rock21=@(t) rock(t);end
if impnum==22;rock22=@(t) rock(t);end
if impnum==23;rock23=@(t) rock(t);end
if impnum==24;rock24=@(t) rock(t);end
if impnum==25;rock25=@(t) rock(t);end
if impnum==26;rock26=@(t) rock(t);end
if impnum==27;rock27=@(t) rock(t);end
if impnum==28;rock28=@(t) rock(t);end
if impnum==29;rock29=@(t) rock(t);end
if impnum==30;rock30=@(t) rock(t);end


%gridd=linspace(fromt,1,50);
%improct=[improct;roct(gridd,Ximp,Yimp)];


end



rockallk=@(t)avgroctk(t,rock1 ,rock2 ,rock3 ,rock4 ,rock5 ,rock6 ,rock7 ,rock8 ,rock9 ,rock10 ,rock11 ,rock12 ,rock13 ,rock14 ,rock15 ,rock16 ,rock17 ,rock18 ,rock19 ,rock20 ,rock21 ,rock22 ,rock23 ,rock24 ,rock25 ,rock26 ,rock27 ,rock28 ,rock29,rock30)
out=rockallk;
end

%plot(t,rockallk(t),'r','LineWidth',2)

