
function [out exitflag r]=rocLODkernBC(xcen1,xcen2,status1, status2, cutlow, cutupp,init)

%Qcdf=@(x,m,s,a,b) ((normcdf(x,m,s)-normcdf(a,m,s))/(normcdf(b,m,s)-normcdf(a,m,s))).*(x>a & b>x) %cdf
Qinv=@(u,m,s,a,b) norminv(normcdf(a,m,s)+u*(normcdf(b,m,s)-normcdf(a,m,s)) ,m,s).*(norminv(normcdf(a,m,s)+u*(normcdf(b,m,s)-normcdf(a,m,s)) ,m,s)>a & b>norminv(normcdf(a,m,s)+u*(normcdf(b,m,s)-normcdf(a,m,s)) ,m,s));  %inv
Qrand=@(m,s,a,b) Qinv(rand,m,s,a,b); %generated a single random number from a truncated normal truncated at [a b].

if nargin==7
[g, roct, exitflag, gval]=boxcoxcens(xcen1,xcen2,status1,status2,init);
elseif nargin==6
[g, roct, exitflag, gval]=boxcoxcens(xcen1,xcen2,status1,status2);
end    
gggggg=g;
lamcen=g(5);
mxhat=g(1);a1hat=mxhat;
sxhat=g(2);b1hat=sxhat;
myhat=g(3);a2hat=myhat;
syhat=g(4);b2hat=syhat;

cutupp=(cutupp^lamcen-1)/lamcen;
cutlow=(cutlow^lamcen-1)/lamcen;
xcen1=(xcen1.^lamcen-1)/lamcen;
xcen2=(xcen2.^lamcen-1)/lamcen;


[cutlow cutupp];

g;

%fromt=X(end-1);
scores=[xcen1;xcen2];

logos1left=length(find(status1==-1));
logos2left=length(find(status2==-1));

logos1right=length(find(status1==1));
logos2right=length(find(status2==1));

%scores=[xcen1;xcen2];
% labels=[xcen1.*0;xcen2./xcen2]
% [Xnai Ynai Tnai AUCnai]=perfcurve(labels,scores,1);
% 
% plot(Xnai, Ynai,'b')

%rocparam=@(t) 1-normcdf(norminv(a1hhat,b1hat),a2hat,b2hat)
%t=0:0.01:1;
%plot(t,rocparam(t),'c')



improct=[];
for impnum=1:30
  impnum;
  
%==================Deal with left censoring
rimp=[];kkk=0;
cut=cutlow;
for i=1:logos1left;
    1;
    while length(rimp)<logos1left;r=Qrand(a1hat,b1hat,-1/lamcen,Inf);%r=normrnd(a1hat,b1hat,1,1);
    r;
    if isnan(r)==1;out=NaN;exitflag=0;return;end
    if r<cut;rimp=[rimp;r];end;
    end
end
ximp1=rimp;
%disp('fine....')
rimp=[];
for i=1:logos2left;
    2;
    while length(rimp)<logos2left;r=Qrand(a2hat,b2hat,-1/lamcen,Inf);%r=normrnd(a2hat,b2hat,1,1);
    if isnan(r)==1;out=NaN;exitflag=0;return;end
    if r<cut;rimp=[rimp;r];end;
    end
end
ximp2=rimp;

xcen1(status1==-1)=ximp1;
xcen2(status2==-1)=ximp2;

%==========================Deal with right censoring

rimp=[];kkk=0;
cut=cutupp;
for i=1:logos1right;
    3;
    while length(rimp)<logos1right;r=Qrand(a1hat,b1hat,-1/lamcen,Inf);%r=normrnd(a1hat,b1hat,1,1);
        [a1hat b1hat  r];
        -1/lamcen;
        if isnan(r)==1;out=NaN;exitflag=0;return;end
    if r>cut;rimp=[rimp;r];end;
    end
end
ximp1=rimp;
%disp('fine....')
rimp=[];
for i=1:logos2right;
    4;
    while length(rimp)<logos2right;r=Qrand(a2hat,b2hat,-1/lamcen,Inf);%r=normrnd(a2hat,b2hat,1,1);
    if isnan(r)==1;out=NaN;exitflag=0;return;end
    if r>cut;rimp=[rimp;r];end;
    end
end
ximp2=rimp;

xcen1(status1==1)=ximp1;
xcen2(status2==1)=ximp2;





%scores=[xcen1;xcen2];
%labels=[zeros(length(xcen1),1);ones(length(xcen2),1)];
%[Ximp Yimp Timp AUCimp(impnum)]=perfcurve(labels,scores,1);
%AUCimp(impnum);
%hold on
%plot(Ximp,Yimp,'g')

%=========kernels================================================
W1a=xcen1;W1b=xcen2;
h1a=0.9*min(std(W1a),iqr(W1a)/1.34)*length(W1a)^(-0.2);
h1b=0.9*min(std(W1b),iqr(W1b)/1.34)*length(W1b)^(-0.2);

Sinv1a=@(t) ksdensity(W1a,1-t,'width',h1a,'function','icdf');
rock=@(t) 1-ksdensity(W1b,Sinv1a(t),'width',h1b,'function','cdf');
%tt=0:0.01:1;
%plot(tt,rock(t),'y')
%=========kernels================================================


if impnum==1;rock1=@(t) rock(t);end
if impnum==2;rock2=@(t) rock(t);end
if impnum==3;rock3=@(t) rock(t);end
if impnum==4;rock4=@(t) rock(t);end
if impnum==5;rock5=@(t) rock(t);end
if impnum==6;rock6=@(t) rock(t);end
if impnum==7;rock7=@(t) rock(t);end
if impnum==8;rock8=@(t) rock(t);end
if impnum==9;rock9=@(t) rock(t);end
if impnum==10;rock10=@(t) rock(t);end
if impnum==11;rock11=@(t) rock(t);end
if impnum==12;rock12=@(t) rock(t);end
if impnum==13;rock13=@(t) rock(t);end
if impnum==14;rock14=@(t) rock(t);end
if impnum==15;rock15=@(t) rock(t);end
if impnum==16;rock16=@(t) rock(t);end
if impnum==17;rock17=@(t) rock(t);end
if impnum==18;rock18=@(t) rock(t);end
if impnum==19;rock19=@(t) rock(t);end
if impnum==20;rock20=@(t) rock(t);end
if impnum==21;rock21=@(t) rock(t);end
if impnum==22;rock22=@(t) rock(t);end
if impnum==23;rock23=@(t) rock(t);end
if impnum==24;rock24=@(t) rock(t);end
if impnum==25;rock25=@(t) rock(t);end
if impnum==26;rock26=@(t) rock(t);end
if impnum==27;rock27=@(t) rock(t);end
if impnum==28;rock28=@(t) rock(t);end
if impnum==29;rock29=@(t) rock(t);end
if impnum==30;rock30=@(t) rock(t);end


%gridd=linspace(fromt,1,50);
%improct=[improct;roct(gridd,Ximp,Yimp)];


end



rockallk=@(t)avgroctk(t,rock1 ,rock2 ,rock3 ,rock4 ,rock5 ,rock6 ,rock7 ,rock8 ,rock9 ,rock10 ,rock11 ,rock12 ,rock13 ,rock14 ,rock15 ,rock16 ,rock17 ,rock18 ,rock19 ,rock20 ,rock21 ,rock22 ,rock23 ,rock24 ,rock25 ,rock26 ,rock27 ,rock28 ,rock29,rock30);
out=rockallk;
end

%plot(t,rockallk(t),'r','LineWidth',2)

