function out=roct(at,X,Y)

%Returns the value of an empirical ROC curve at a specific FPR value "at".
%X and Y are the coordinates of an ROC curve as obtained by "perfcurve".
if length(find(X==at))>0
    out=max(Y(find(X==at)));
else
    at1=max(find(X<at));
    at2=at1+1;
    if Y(at1)==Y(at2);out=Y(at1);end
    if Y(at1)~=Y(at2);
        
        XX=[1 X(at1);1 X(at2)];
        YY=[Y(at1) Y(at2)]';
        bb=inv(XX'*XX)*XX'*YY;
        f=@(x) bb(1)+bb(2).*x;
        out=f(at);
    end
end
out;
end
